<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/23/2003 *
 * ===============                              Last change: 09/23/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-add_points.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Add manually points to a user                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Manuell einem Mitglied Punkte gutschreiben       *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}
// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

// Fix a notice
if (!isset($_GET['u_id'])) $_GET['u_id'] = "";

OPEN_TABLE("100%", "admin_content admin_content_align", "");
if ($_GET['u_id'] == "all")
{
	// Add points to all accounts
	if ((isset($_POST['ok'])) && ($_POST['points'] > 0))
	{
		define('__POINTS_VALUE', $_POST['points']);
		$result_main = SQL_QUERY("SELECT userid FROM "._MYSQL_PREFIX."_user_data WHERE status='CONFIRMED' ORDER BY userid", __FILE__, __LINE__);
		while (list($uid) = SQL_FETCHROW($result_main))
		{
			// User ID found in URL so we use this give him some credits
			$result = SQL_QUERY_ESC("SELECT surname, family, email FROM "._MYSQL_PREFIX."_user_data WHERE userid=%s AND status='CONFIRMED' LIMIT 1",
			 array(bigintval($uid)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1)
			{
				// Selected user does exist
				list($sname, $fname, $email) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);

				if ((isset($_POST['ok'])) && (!empty($_POST['points'])))
				{
					// Ok, add points and send an email to him...
					$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_user_points SET points=points+(%s) WHERE userid=%s AND ref_depth=0 LIMIT 1",
					 array($_POST['points'], bigintval($uid)), __FILE__, __LINE__);

					// Update mediadata as well
					if (GET_EXT_VERSION("mediadata") >= "0.0.4")
					{
						// Update database
						MEDIA_UPDATE_ENTRY(array("total_points"), "add", $_POST['points']);
					}

					// Load email template and send email away
					$msg = LOAD_EMAIL_TEMPLATE("add-points", $_POST['reason'], $uid);
					SEND_EMAIL($email, ADMIN_ADD_SUBJ, $msg);
				}
			}
		}

		// Free memory
		SQL_FREERESULT($result_main);

		// Output message
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_ALL_POINTS_ADDED);
	}
	 else
	{
		// Display form add points
		LOAD_TEMPLATE("admin_add_points_all");
	}
}
 elseif (!empty($_GET['u_id']))
{
	// User ID found in URL so we use this give him some credits
	$result = SQL_QUERY_ESC("SELECT surname, family, email FROM "._MYSQL_PREFIX."_user_data WHERE userid=%s AND status='CONFIRMED' LIMIT 1",
	 array(bigintval($_GET['u_id'])), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1)
	{
		// Selected user does exist
		list($sname, $fname, $email) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		if ((isset($_POST['ok'])) && (!empty($_POST['points'])))
		{
			// Ok, add points and send an email to him...
			$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_user_points SET points=points+(%s) WHERE userid=%s AND ref_depth=0 LIMIT 1",
			 array($_POST['points'], bigintval($_GET['u_id'])), __FILE__, __LINE__);

			// Remember points in constant
			define('__POINTS_VALUE', $_POST['points']);

			// Message laden
			$msg = LOAD_EMAIL_TEMPLATE("add-points", $_POST['reason'], $_GET['u_id']);

			SEND_EMAIL($email, ADMIN_ADD_SUBJ, $msg);
			LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_POINTS_ADDED);
		}
		 else
		{
			// Opps, missing form here
			define('__USER_VALUE', "<A href=\"".CREATE_EMAIL_LINK($email, "user_data")."\">".$sname." ".$fname."</A>");
			define('__UID_VALUE', $_GET['u_id']);
			LOAD_TEMPLATE("admin_add_points");
		}
	}
	 else
	{
		// User not found!
		OUTPUT_HTML("<STRONG class=\"admin_failed\">".ADMIN_MEMBER_404_1.$_GET['u_id'].ADMIN_MEMBER_404_2."</STRONG>");
	}
}
 else
{
	// Output selection form with all confirmed user accounts listed
	ADD_MEMBER_SELECTION_BOX(true);
}
CLOSE_TABLE();
//
?>
